###############################################################################
###############################################################################
##
##  Copyright (C) 2004-2009 Red Hat, Inc.  All rights reserved.
##
##  This copyrighted material is made available to anyone wishing to use,
##  modify, copy, or redistribute it subject to the terms and conditions
##  of the GNU General Public License v.2.
##
###############################################################################
###############################################################################

# main (empty) package
# http://www.rpm.org/max-rpm/s1-rpm-subpack-spec-file-changes.html

# keep around ready for later user
## define alphatag rc4

Name: cluster
Summary: Red Hat Cluster
Version: 3.0.5
Release: 1%{?alphatag:.%{alphatag}}%{?dist}
License: GPLv2+ and LGPLv2+
Group: System Environment/Base
URL: http://sources.redhat.com/cluster/wiki/
Source0: ftp://sources.redhat.com/pub/cluster/releases/cluster-%{version}%{?alphatag:.%{alphatag}}.tar.gz

## Setup/build bits

BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)

# Build dependencies
BuildRequires: perl python
BuildRequires: glibc-kernheaders glibc-devel
BuildRequires: libxml2-devel ncurses-devel
BuildRequires: corosynclib-devel >= 1.0.0-1
BuildRequires: openaislib-devel >= 1.0.0-1
BuildRequires: openldap-devel perl(ExtUtils::MakeMaker)

%prep
%setup -q -n cluster-%{version}%{?alphatag:.%{alphatag}}

%build
./configure \
  --sbindir=%{_sbindir} \
  --initddir=%{_sysconfdir}/rc.d/init.d \
  --libdir=%{_libdir} \
  --without_fence_agents \
  --without_rgmanager \
  --without_resource_agents \
  --without_kernel_modules \
  --disable_kernel_check

##CFLAGS="$(echo '%{optflags}')" make %{_smp_mflags}
CFLAGS="$(echo '%{optflags}')" make

%install
rm -rf %{buildroot}
make install DESTDIR=%{buildroot}

## tree fix up
# logrotate name
mv %{buildroot}%{_sysconfdir}/logrotate.d/cluster \
	%{buildroot}%{_sysconfdir}/logrotate.d/cman
# remove static libraries
find %{buildroot} -name "*.a" -exec rm {} \;
# fix library permissions or fedora strip helpers won't work.
find %{buildroot} -name "lib*.so.*" -exec chmod 0755 {} \;
# fix lcrso permissions or fedora strip helpers won't work.
find %{buildroot} -name "*.lcrso" -exec chmod 0755 {} \;
# remove docs
rm -rf %{buildroot}/usr/share/doc/cluster
# cleanup perl bindings bits
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -type f -name perllocal.pod -exec rm -f {} \;
find %{buildroot} -type f -name '*.bs' -a -empty -exec rm -f {} \;
find %{buildroot} -type f -name CCS.so -exec chmod 755 {} \;

%clean
rm -rf %{buildroot}

## Runtime and subpackages section

# main empty package
%description
Red Hat Cluster

## subpackages

%package -n cman
Group: System Environment/Base
Summary: Red Hat Cluster Manager
Requires(post): chkconfig
Requires(preun): initscripts
Requires(preun): chkconfig
Requires: corosync >= 1.0.1-1
Requires: openais >= 1.0.2-1
Requires: perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires: ricci >= 0.15.0-4 modcluster >= 0.15.0-3
Requires: fence-agents >= 3.0.4-1

%description -n cman
Red Hat Cluster Manager

%post -n cman
/sbin/chkconfig --add cman

# make sure to stop cman always as last
%preun -n cman
if [ "$1" = 0 ]; then
	/sbin/service cman stop >/dev/null 2>&1
	/sbin/chkconfig --del cman
fi

%files -n cman
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence doc/*.txt config/plugins/ldap/*.ldif
%dir %{_sysconfdir}/cluster
%{_sysconfdir}/rc.d/init.d/cman
%dir %{_sysconfdir}/cluster/cman-notify.d
%config(noreplace) %{_sysconfdir}/logrotate.d/cman
%{_sbindir}/ccs*
%{_sbindir}/cman*
%{_sbindir}/confdb2ldif
%{_sbindir}/dlm_controld
%{_sbindir}/dlm_tool
%{_sbindir}/fence*
%{_sbindir}/gfs_control
%{_sbindir}/gfs_controld
%{_sbindir}/group*
%{_sbindir}/*qdisk*
/usr/libexec/*
%dir %{_datadir}/cluster
%{_datadir}/cluster/cluster.rng
%{perl_vendorarch}/*
%dir /var/log/cluster
%{_mandir}/man5/*
%{_mandir}/man8/ccs*
%{_mandir}/man8/cman*
%{_mandir}/man8/confdb2ldif*
%{_mandir}/man8/dlm*
%{_mandir}/man8/fence*
%{_mandir}/man8/gfs_control*
%{_mandir}/man8/group*
%{_mandir}/man8/*qdisk*
%{_mandir}/man3/*.3pm.gz

%package -n clusterlib
Group: System Environment/Libraries
Summary: The Red Hat Cluster libraries
Conflicts: cman < 3.0.3-1
Provides: cmanlib = %{version}
Obsoletes: cmanlib < 3.0.0-5.alpha4

%description -n clusterlib
The Red Hat Cluster libraries package

%files -n clusterlib
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence
%config(noreplace) %{_sysconfdir}/udev/rules.d/*-dlm.rules
%{_libdir}/libcman.so.*
%{_libdir}/libccs*.so.*
%{_libdir}/libdlm*.so.*
%{_libdir}/libfence*.so.*
%{_libdir}/liblogthread*.so.*

%post -n clusterlib -p /sbin/ldconfig

%postun -n clusterlib -p /sbin/ldconfig

%package -n clusterlib-devel
Group: Development/Libraries
Summary: The Red Hat Cluster libraries development package
Requires: clusterlib = %{version}-%{release}
Requires: pkgconfig
Provides: cman-devel = %{version}
Obsoletes: cman-devel < 3.0.0-5.alpha4
Provides: cmanlib-devel = %{version}
Obsoletes: cmanlib-devel < 3.0.0-5.alpha4

%description -n clusterlib-devel
The Red Hat Cluster libraries development package

%files -n clusterlib-devel
%defattr(-,root,root,-)
%doc doc/COPYING.* doc/COPYRIGHT doc/README.licence
%{_libdir}/libcman.so
%{_libdir}/libccs*.so
%{_libdir}/libdlm*.so
%{_libdir}/libfence*.so
%{_libdir}/liblogthread*.so
%{_includedir}/ccs.h
%{_includedir}/libcman.h
%{_includedir}/libdlm*.h
%{_includedir}/libfence.h
%{_includedir}/libfenced.h
%{_includedir}/liblogthread.h
%{_mandir}/man3/*3.gz
%{_libdir}/pkgconfig/*.pc

%package -n gfs2-utils
Group: System Environment/Kernel
Summary: Utilities for managing the global filesystem (GFS2)
Requires(post): chkconfig
Requires(preun): initscripts
Requires(preun): chkconfig
Requires: file

%description -n gfs2-utils
The gfs2-utils package contains a number of utilities for creating,
checking, modifying, and correcting any inconsistencies in GFS2
filesystems.

%post -n gfs2-utils
/sbin/chkconfig --add gfs2

%preun -n gfs2-utils
if [ "$1" = 0 ]; then
	/sbin/service gfs2 stop >/dev/null 2>&1
	/sbin/chkconfig --del gfs2
fi

%files -n gfs2-utils
%defattr(-,root,root,-)
%doc doc/COPYRIGHT doc/README.licence doc/COPYING.*
%{_sysconfdir}/rc.d/init.d/gfs2
/sbin/*.gfs2
%{_sbindir}/*gfs2*
%{_mandir}/man8/*gfs2*

%package -n gfs-utils
Group: System Environment/Kernel
Summary: Utilities for managing the global filesystem (GFS)
Requires(post): chkconfig
Requires(preun): initscripts
Requires(preun): chkconfig
Requires: gfs2-utils
Requires: file

%description -n gfs-utils
The gfs-utils package contains a number of utilities for creating,
checking, modifying, and correcting any inconsistencies in GFS
filesystems. This package requires the GFS kernel module.

%post -n gfs-utils
/sbin/chkconfig --add gfs

%preun -n gfs-utils
if [ "$1" = 0 ]; then
	/sbin/service gfs stop >/dev/null 2>&1
	/sbin/chkconfig --del gfs
fi

%files -n gfs-utils
%defattr(-,root,root,-)
%doc doc/COPYRIGHT doc/README.licence doc/COPYING.*
%{_sysconfdir}/rc.d/init.d/gfs
/sbin/*.gfs
%{_sbindir}/gfs_debug
%{_sbindir}/gfs_edit
%{_sbindir}/gfs_grow
%{_sbindir}/gfs_jadd
%{_sbindir}/gfs_quota
%{_sbindir}/gfs_tool
%{_mandir}/man8/gfs.*
%{_mandir}/man8/gfs_edit*
%{_mandir}/man8/gfs_grow*
%{_mandir}/man8/gfs_jadd*
%{_mandir}/man8/gfs_quota*
%{_mandir}/man8/gfs_tool*
%{_mandir}/man8/*.gfs.*

%changelog
* Fri Nov 20 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.5-1
- New upstream release
- spec file update:
  * drop BuildRequires on slang-devel.

* Wed Oct 21 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.4-1
- New upstream release
- spec file update:
  * explicitly Requires newer version of fence-agents

* Fri Oct  9 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.3-1
- New upstream release
- spec file updates:
  * drop cp_workaround patch
  * stop shipping rgmanager from cluster
  * move dlm udev rules in clusterlib where they belong

* Mon Aug 24 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.2-2
- Add temporary workaround to install symlinks

* Mon Aug 24 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.2-1
- New upstream release

* Thu Aug 20 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.1-1
- New upstream release

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.0-21
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Jul  8 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-20
- New upstream release
- spec file updates:
  * Update copyright header
  * final release.. undefine alphatag
  * BuildRequires and Requires corosync/openais 1.0.0-1 final.

* Thu Jul  2 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-19.rc4
- New upstream release
- spec file updates:
  * cman subpackage: avoid unnecessary calls to ldconfig
  * rgmanager subpackage: drop unrequired Requires: that belong to ras
  * BuildRequires and Requires corosync/openais 1.0.0.rc1

* Sat Jun 20 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-18.rc3
- New upstream release
- spec file updates:
  * Drop local patches.
  * Update BuildRequires and Requires: on newer corosync/openais.

* Thu Jun 11 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-17.rc2
- Update from git up to 779dd3c23ca6c56f5b3f7a8a7831bae775c85201
- spec file updates:
  * Drop BuildRequires on libvolume_id-devel that's now obsoleted
  * gfs*-utils now Requires: file
  * Add temporary patch to get rid of volume_id references in the code

* Wed Jun 10 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-16.rc2
- New upstream release + git94df30ca63e49afb1e8aeede65df8a3e5bcd0970
- spec file updates:
  * BuildRequires / Requires: latest corosync and openais
  * Update configure invokation
  * Cleanup tree fix up bits that are now upstream
  * Ship cluster.rng
  * Move fsck/mkfs gfs/gfs2 binaries in /sbin to be FHS compliant

* Tue Mar 24 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-15.rc1
- New upstream release.
- Update corosync/openais BuildRequires and Requires.
- Drop --corosynclibdir from configure. Libs are now in standard path.
- Update BuildRoot usage to preferred versions/names
- Drop qdisk init script. Now merged in cman init from upstream.

* Mon Mar  9 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-14.alpha7
- New upstream release.
- Update corosync/openais BuildRequires and Requires.
- Fix gfs-utils and cman man page overlapping files.

* Fri Mar  6 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-13.alpha7
- New upstream release.
- Drop local build fix patch.

* Tue Mar  3 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-12.alpha6
- New upstream release.
- Add missing LICENCE and COPYRIGHT files from clusterlib-devel.
- Add patch to fix build failure (already upstream).

* Tue Feb 24 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-11.alpha5
- Stop building fence and resource agents.
- cman now Requires: fence-agents.
- rgmanager now Requires: resource-agents.

* Tue Feb 24 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-10.alpha5
- Fix typo in gfs-utils preun scriptlet.
- Fix gfs-utils file list.

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.0.0-9.alpha5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Feb 23 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-8.alpha5
- New upstream release.

* Thu Feb 19 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-7.alpha4
- Update to latest stable3 code from git (e3a9ac674fa0ff025e833dcfbc8575cada369843)
- Fix Provides: version.
- Update corosync/openais BuildRequires and Requires

* Fri Feb  6 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-6.alpha4
- Fix datadir/fence directory ownership.

* Sat Jan 31 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-5.alpha4
- New upstream release.
- Fix directory ownership #483330.
- Add support pkgconfig to devel package.
- Total libraries cleanup:
  - split libraries out of cman into clusterlib.
  - merge cmanlib into clusterlib.
  - rename cman-devel into clusterlib-devel.
  - merge cmanlib-devel into clusterlib-devel.
- Comply with multiarch requirements (libraries).
- Relax BuildRequires and Requires around corosync and openais.

* Tue Jan 27 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-4.alpha3
- New upstream release

* Wed Jan 21 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-3.alpha2
- Move all binaries where they belong. All the legacy stuff is now dead.

* Mon Jan 12 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-2.alpha2
- New upstream release (retag cvs package)

* Mon Jan 12 2009 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-1.alpha2
- New upstream release

* Wed Dec 17 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 3.0.0-1.alpha1
- New upstream release.
- Fix legacy code build.
- Fix wrong conffile attribute.

* Mon Dec 15 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.13-1
- New upstream release.
- Drop gnbd* packages that are now a separate project.
- Tight dependencies with corosync/openais.

* Mon Dec 01 2008 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 2.99.12-2
- Rebuild for Python 2.6

* Mon Nov  3 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.12-1
- new upstream release.
  Fix several security related issues.

* Mon Oct 20 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.11-1
- new upstream release.
- drop obsoleted patches.
- include very important gfs1 bug fix.
- include fix for fence_egenera (CVE-2008-4192).

* Wed Oct  8 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-6
- cman init: add fix from upstream for cman_tool wrong path.

* Fri Sep 26 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-5
- cman now Requires: ricci and modcluster.

* Fri Sep 26 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-4
- Split libcman.so* from cman and cman-devel into  cmanlib and cmanlib-devel
  to break a very annoying circular dependency.

* Thu Sep 25 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-3
- The "CVS HATES ME" release.
- New upstream release.
- Build against new corosync and openais.
- specfile cleanup: rename buildxen to buildvirt.

* Thu Sep 25 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-2
- Retag release.
- New upstream release.
- Build against new corosync and openais.
- specfile cleanup: rename buildxen to buildvirt.

* Thu Sep 25 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.10-1
- New upstream release.
- Build against new corosync and openais.
- specfile cleanup: rename buildxen to buildvirt.

* Wed Sep 03 2008 Jesse Keating <jkeating@redhat.com> - 2.99.08-3
- Rebuild for broken deps.
- Pull in upstream patches for libvolume_id changes

* Wed Sep 03 2008 Jesse Keating <jkeating@redhat.com> - 2.99.08-2
- Rebuild for broken deps.

* Tue Aug 12 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.08-1
- New upstream release.
- Drop local patch that's part of upstream.
- Tight BR and Requires for openais to a very specific version.
- cman Requires ricci as new default config distribution system.
  (ricci changes will land soon but in the meantime this is done our side)

* Fri Aug  1 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.07-1
- New upstream release.
- Add patch to build against new headers (already part of upstream next release)
- BR on perl(ExtUtils::MakeMaker) to build perl bindings
- Fix logrotate install from upstream
- Add "clean up after perl bindings" snippet
- Update Requires for perl bindings
- Properly split man3 man pages

* Tue Jul 15 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.06-1
- New upstream release.
- BR on new openais for logging features.
- drop local logrotate snippet in favour of upstream one.
- cman Requires: PyOpenSSL for telnet_ssl wrapper.
- cman Requires: pexpect and net-snmp-utils for fence agents.
  Thanks to sendro on IRC for spotting the issue.
- Another cleanup round for docs

* Tue Jun 24 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.05-1
- New upstream release
- Update licence tags again after upstream relicensing to kill OSL 2.1.
- Add 2 commodity packages (gfs-utils and gnbd-utils). They both
  require external kernel modules but at least userland will stay
  automatically in sync for our users.
- BR openais 0.84 for new logsys symbols (and requires for runtime).
- Update build section to enable gfs-utils and gnbd-utils.

* Mon Jun  9 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.04-1
- New upstream release
- Update license tags after major upstream cleanup (note: rgmanager
  includes a shell script that is shipped under OSL 2.1 license).
- Update inclusion of documents to reflect updated COPYRIGHT file
  from upstream.
- Add documentation to different packages.

* Mon Jun  2 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.03-1
- New upstream release
- cman Requires telnet and ssh client
- drops some tree fix up bits that are now upstream

* Fri May 23 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.02-4
- Add missing OpenIPMI requires to cman for fence_ipmilan

* Thu May 22 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.02-3
- New kernel-headers has what we need release.
- Drop BR on kernel-devel.
- Drop cluster-dlmheaders.patch.
- Drop --kernel_* from configure invokation.
- Cleanup a few comments in the spec file.

* Tue May 20 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.02-2
- disable parallel build (broken upstream)
- build requires higher openais (fix ppc64 build failure)

* Mon May 19 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.02-1
- New upstream release
- Shut up the last few rpmlint warnings

* Wed May 15 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.01-4
- Fix typo in rgmanager Summary

* Wed May 14 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.01-3
- Fix rgmanager License: tag.

* Wed May 14 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.01-2
- Drop BR on openais as it is pulled by openais-devel.
- Change postun section to use -p /sbin/ldconfig.
- Fix rgmanager Requires.

* Wed May 14 2008 Fabio M. Di Nitto <fdinitto@redhat.com> - 2.99.01-1
- Initial packaging.
